#
# Conditional build:
%bcond_without	lmdb	# LMDB module (64-bit only)
#
%ifnarch %{x8664} aarch64 alpha mips64 ppc64 s390x sparc64
# lmdb support requires 64-bit size_t
%undefine	with_lmdb
%endif
%define		talloc_version	2:2.3.3
%define		tdb_version	2:1.4.3
%define		tevent_version	0.10.2
Summary:	LDAP-like embedded database
Summary(pl.UTF-8):	Wbudowana baza danych podobna do LDAP
Name:		ldb
Version:	2.4.1
Release:	1
License:	LGPL v3+
Group:		Libraries
Source0:	https://download.samba.org/pub/ldb/%{name}-%{version}.tar.gz
# Source0-md5:	ec2baff9c8e02fcbdd570401420589d5
URL:		https://ldb.samba.org/
BuildRequires:	cmocka-devel >= 1.1.3
BuildRequires:	docbook-style-xsl
BuildRequires:	libbsd-devel
BuildRequires:	libxslt-progs
%{?with_lmdb:BuildRequires:	lmdb-devel >= 0.9.16}
BuildRequires:	openldap-devel
BuildRequires:	popt-devel >= 1.6
BuildRequires:	python3-devel >= 1:3.2
BuildRequires:	python3-talloc-devel >= %{talloc_version}
BuildRequires:	python3-tdb >= %{tdb_version}
BuildRequires:	python3-tevent >= %{tevent_version}
BuildRequires:	rpmbuild(macros) >= 1.704
BuildRequires:	talloc-devel >= %{talloc_version}
BuildRequires:	tdb-devel >= %{tdb_version}
BuildRequires:	tevent-devel >= %{tevent_version}
%{?with_lmdb:Requires:	lmdb >= 0.9.16}
Requires:	talloc >= %{talloc_version}
Requires:	tdb >= %{tdb_version}
Requires:	tevent >= %{tevent_version}
Requires:	popt >= 1.6
Provides:	libldb = %{version}-%{release}
Obsoletes:	libldb < 1.1.0-3
# ldb 1.6+ dropped python2 support
Obsoletes:	python-ldb < 1.6
Obsoletes:	python-ldb-devel < 1.6
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
An extensible library that implements an LDAP like API to access
remote LDAP servers, or use local tdb databases.

%description -l pl.UTF-8
Rozszerzalna biblioteka implementująca API podobne do LDAP pozwalające
na dostęp do zdalnych serwerów LDAP lub wykorzystanie lokalnych baz
danych tdb.

%package tools
Summary:	Tools to manage LDB files
Summary(pl.UTF-8):	Narzędzia do zarządzania plikami LDB
Group:		Applications/Databases
Requires:	%{name} = %{version}-%{release}

%description tools
Tools to manage LDB files.

%description tools -l pl.UTF-8
Narzędzia do zarządzania plikami LDB.

%package devel
Summary:	Header files for the LDB library
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki LDB
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	talloc-devel >= %{talloc_version}
Requires:	tdb-devel >= %{tdb_version}
Requires:	tevent-devel >= %{tevent_version}
Provides:	libldb-devel = %{version}-%{release}
Obsoletes:	libldb-devel < 1.1.0-3

%description devel
Header files needed to develop programs that link against the LDB
library.

%description devel -l pl.UTF-8
Pliki nagłówkowe potrzebne do tworzenia programów wykorzystujących
bibliotekę LDB.

%package -n python3-ldb
Summary:	Python 3 bindings for the LDB library
Summary(pl.UTF-8):	Wiązania Pythona 3 do biblioteki LDB
Group:		Libraries/Python
Requires:	%{name} = %{version}-%{release}
Requires:	python3-tdb >= %{tdb_version}
Obsoletes:	pyldb < 1.1.0-1

%description -n python3-ldb
Python 3 bindings for the LDB library.

%description -n python3-ldb -l pl.UTF-8
Wiązania Pythona 3 do biblioteki LDB.

%package -n python3-ldb-devel
Summary:	Development files for the Python 3 bindings for the LDB library
Summary(pl.UTF-8):	Pliki programistyczne wiązań Pythona 3 do biblioteki LDB
Group:		Development/Libraries
Requires:	python3-ldb = %{version}-%{release}

%description -n python3-ldb-devel
Development files for the Python 3 bindings for the LDB library.

%description -n python3-ldb-devel -l pl.UTF-8
Pliki programistyczne wiązań Pythona 3 do biblioteki LDB.

%prep
%setup -q

%build
CC="%{__cc}" \
CFLAGS="%{rpmcflags}" \
./configure \
	--prefix=%{_prefix} \
	--libdir=%{_libdir} \
	--with-modulesdir=%{_libdir}/ldb/modules \
	--with-privatelibdir=%{_libdir}/ldb \
	--bundled-libraries=NONE \
	--disable-rpath \
	--disable-rpath-install

%{__make} \
	V=1

%install
rm -rf $RPM_BUILD_ROOT
%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

%py3_comp $RPM_BUILD_ROOT%{py3_sitedir}
%py3_ocomp $RPM_BUILD_ROOT%{py3_sitedir}

# Shared libraries need to be marked executable for
# rpmbuild to strip them and include them in debuginfo
find $RPM_BUILD_ROOT -name "*.so*" -exec chmod -c +x {} ';'

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%post	-n python3-ldb -p /sbin/ldconfig
%postun	-n python3-ldb -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libldb.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libldb.so.2
%dir %{_libdir}/ldb
%attr(755,root,root) %{_libdir}/ldb/libldb-key-value.so
%attr(755,root,root) %{_libdir}/ldb/libldb-tdb-err-map.so
%attr(755,root,root) %{_libdir}/ldb/libldb-tdb-int.so
%{?with_lmdb:%attr(755,root,root) %{_libdir}/ldb/libldb-mdb-int.so}
%dir %{_libdir}/ldb/modules
%dir %{_libdir}/ldb/modules/ldb
%attr(755,root,root) %{_libdir}/ldb/modules/ldb/*.so

%files tools
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/ldbadd
%attr(755,root,root) %{_bindir}/ldbdel
%attr(755,root,root) %{_bindir}/ldbedit
%attr(755,root,root) %{_bindir}/ldbmodify
%attr(755,root,root) %{_bindir}/ldbrename
%attr(755,root,root) %{_bindir}/ldbsearch
%attr(755,root,root) %{_libdir}/ldb/libldb-cmdline.so
%{_mandir}/man1/ldbadd.1*
%{_mandir}/man1/ldbdel.1*
%{_mandir}/man1/ldbedit.1*
%{_mandir}/man1/ldbmodify.1*
%{_mandir}/man1/ldbrename.1*
%{_mandir}/man1/ldbsearch.1*

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libldb.so
%{_includedir}/ldb_module.h
%{_includedir}/ldb_handlers.h
%{_includedir}/ldb_errors.h
%{_includedir}/ldb_version.h
%{_includedir}/ldb.h
%{_pkgconfigdir}/ldb.pc
%{_mandir}/man3/ldb.3*

%files -n python3-ldb
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libpyldb-util.cpython-3*.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libpyldb-util.cpython-3*.so.2
%attr(755,root,root) %{py3_sitedir}/ldb.cpython-*.so
%{py3_sitedir}/_ldb_text.py
%{py3_sitedir}/__pycache__/_ldb_text.cpython-*.py[co]

%files -n python3-ldb-devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libpyldb-util.cpython-3*.so
%{_includedir}/pyldb.h
%{_pkgconfigdir}/pyldb-util.cpython-3*.pc
%changelog
* Wed Nov 10 2021 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/ldb.git;a=log;h=master

* Wed Nov 10 2021 Arkadiusz Miśkiewicz <arekm@maven.pl> 9e5c774
- Up to 2.4.1.

* Thu Jul 08 2021 Marcin Krol <hawk@tld-linux.org> 5bcca94
- updated to 2.3.0

* Thu Mar 25 2021 Jakub Bogusz <qboosh@pld-linux.org> 5d02873
- versioned Obsoletes

* Thu Mar 25 2021 Jakub Bogusz <qboosh@pld-linux.org> de67fb3
- updated to 2.2.1

* Sat Feb 27 2021 Jan Rękorajski <baggins@pld-linux.org> 7f24ac6
- release 2 (by relup.sh)

* Thu Oct 29 2020 Marcin Krol <hawk@tld-linux.org> 7cee282
- updated to 2.2.0

* Sun Aug 16 2020 Jakub Bogusz <qboosh@pld-linux.org> 0ea65ae
- updated to 2.1.4

* Fri May 22 2020 Jakub Bogusz <qboosh@pld-linux.org> 62e4c4b
- updated to 2.1.3

* Wed Mar 25 2020 Arkadiusz Miśkiewicz <arekm@maven.pl> 89c6635
- up to 2.1.1

* Sat Jan 11 2020 Jakub Bogusz <qboosh@pld-linux.org> 74bbb00
- BR: libbsd-devel

* Mon Dec 16 2019 Arkadiusz Miśkiewicz <arekm@maven.pl> 8fce453
- up to 2.0.8

* Sun Nov 17 2019 Jakub Bogusz <qboosh@pld-linux.org> 23ee5a8
- updated tdb dependency, removed no longer needed _duplicate_files_terminate_build define

* Mon Nov 04 2019 Jan Rękorajski <baggins@pld-linux.org> 9ed09a0
- add O for dropped python packages
- rel 2

* Wed Oct 30 2019 Arkadiusz Miśkiewicz <arekm@maven.pl> bc22b6e
- up to 2.0.7; python 2 support dropped upstream

* Mon Oct 28 2019 Jan Rękorajski <baggins@pld-linux.org> 723dcc1
- rebuild with python 3.8
- release 2 (by relup.sh)

* Thu Oct 17 2019 Jakub Bogusz <qboosh@pld-linux.org> 9d48dd3
- updated to 1.5.6

* Tue Jul 23 2019 Jakub Bogusz <qboosh@pld-linux.org> 03a9f97
- updated to 1.5.5

* Wed Apr 10 2019 Jakub Bogusz <qboosh@pld-linux.org> 1e9fe69
- removed obsolete comment

* Thu Mar 21 2019 Marcin Krol <hawk@tld-linux.org> b3d015f
- BR: cmocka-devel >= 1.1.3

* Wed Mar 20 2019 Adam Gołębiowski <adamg@pld-linux.org> e7bf297
- updated to 1.5.4 (1.4.x on LDB_1_4 branch)
- reverse python bcond logic, make python3 default

